-- AYCT_DataPostProcessing
-- Author: Castar
-- DateCreated: 3/4/2019 6:49:08 PM
--------------------------------------------------------------

-------------------------------------
-- Improvement_FeatureYieldChanges --
-------------------------------------

CREATE TEMPORARY TABLE AYCT_Improvements_FeatureYieldChanges_Strings AS 
SELECT substr(ImprovementType,13) AS Improvement, substr(FeatureType,9) AS Feature, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange
FROM Improvement_FeatureYieldChanges;

-- Modifiers for when no feature is present
INSERT INTO Modifiers
		(ModifierId,									ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								)
SELECT	Improvement||'_NO_FEATURE_'||Yield,				'MODIFIER_SINGLE_PLOT_ADJUST_PLOT_YIELDS',	'0',		'0',		'0',		'PLOT_HAS_NO_FEATURE_REQUIREMENTS'
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is null;

INSERT INTO ModifierArguments 
		(ModifierId,								Name,			Type,				Value				)
SELECT	Improvement||'_NO_FEATURE_'||Yield,			'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is null;

INSERT INTO ModifierArguments 
		(ModifierId,								Name,			Type,				Value				)
SELECT	Improvement||'_NO_FEATURE_'||Yield,			'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is null;

INSERT INTO ImprovementModifiers
		(ImprovementType,				ModifierID									)
SELECT	'IMPROVEMENT_'||Improvement,	Improvement||'_NO_FEATURE_'||Yield
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is null;

-- Modifiers for when a specific feature is present
INSERT INTO Modifiers
		(ModifierId,									ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								)
SELECT	Improvement||'_ADD_'||Feature||'_'||Yield,		'MODIFIER_SINGLE_PLOT_ADJUST_PLOT_YIELDS',	'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_REQUIREMENTS'
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is not null;

INSERT INTO ModifierArguments 
		(ModifierId,										Name,			Type,				Value				)
SELECT	Improvement||'_ADD_'||Feature||'_'||Yield,			'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is not null;

INSERT INTO ModifierArguments 
		(ModifierId,										Name,			Type,				Value				)
SELECT	Improvement||'_ADD_'||Feature||'_'||Yield,			'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is not null;

INSERT INTO ImprovementModifiers
		(ImprovementType,				ModifierID									)
SELECT	'IMPROVEMENT_'||Improvement,	Improvement||'_ADD_'||Feature||'_'||Yield
FROM	AYCT_Improvements_FeatureYieldChanges_Strings
WHERE	Feature is not null;

DROP TABLE AYCT_Improvements_FeatureYieldChanges_Strings;

--------------------------------------
-- Improvement_ResourceYieldChanges --
--------------------------------------

CREATE TEMPORARY TABLE AYCT_Improvements_ResourceYieldChanges_Strings AS 
SELECT substr(ImprovementType,13) AS Improvement, substr(ResourceType,10) AS Resource, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange
FROM Improvement_ResourceYieldChanges;

-- Modifiers for when no visible resource is present
INSERT INTO Modifiers
		(ModifierId,									ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								)
SELECT	Improvement||'_NO_RESOURCES_'||Yield,			'MODIFIER_SINGLE_PLOT_ADJUST_PLOT_YIELDS',	'0',		'0',		'0',		'PLOT_HAS_NO_VISIBLE_RESOURCES_REQUIREMENTS'
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is null;

INSERT INTO ModifierArguments 
		(ModifierId,								Name,			Type,				Value				)
SELECT	Improvement||'_NO_RESOURCES_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is null;

INSERT INTO ModifierArguments 
		(ModifierId,								Name,			Type,				Value				)
SELECT	Improvement||'_NO_RESOURCES_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is null;

INSERT INTO ImprovementModifiers
		(ImprovementType,				ModifierID									)
SELECT	'IMPROVEMENT_'||Improvement,	Improvement||'_NO_RESOURCES_'||Yield
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is null;


-- Modifiers for when a visible resource is present
INSERT INTO Modifiers
		(ModifierId,									ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								)
SELECT	Improvement||'_ADD_'||Resource||'_'||Yield,		'MODIFIER_SINGLE_PLOT_ADJUST_PLOT_YIELDS',	'0',		'0',		'0',		'PLOT_HAS_IMPROVED_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is not null;

INSERT INTO ModifierArguments 
		(ModifierId,									Name,			Type,				Value				)
SELECT	Improvement||'_ADD_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is not null;

INSERT INTO ModifierArguments 
		(ModifierId,									Name,			Type,				Value				)
SELECT	Improvement||'_ADD_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is not null;

INSERT INTO ImprovementModifiers
		(ImprovementType,				ModifierID									)
SELECT	'IMPROVEMENT_'||Improvement,	Improvement||'_ADD_'||Resource||'_'||Yield
FROM	AYCT_Improvements_ResourceYieldChanges_Strings
WHERE	Resource is not null;

DROP TABLE AYCT_Improvements_ResourceYieldChanges_Strings;

-------------------------------------
-- Technology_ResourceYieldChanges --
-------------------------------------

CREATE TEMPORARY TABLE AYCT_Technology_ResourceYieldChanges_Strings AS
SELECT substr(TechnologyType, 6) AS Technology, substr(ResourceType,10) AS Resource, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange, Improved AS Improved, Unimproved AS Unimproved
FROM Technology_ResourceYieldChanges;

-- Modifiers for improved = 1, unimproved = 0
INSERT INTO Modifiers
		(ModifierId,											ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Technology||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_IMPROVED_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId													) 
SELECT	'TECH_'||Technology,	Technology||'_ADD_IMPROVED_'||Resource||'_'||Yield		
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

-- Modifiers for improved = 0, unimproved = 1
INSERT INTO Modifiers
		(ModifierId,											ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Technology||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,	'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_UNIMPROVED_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,	'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,	'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId													) 
SELECT	'TECH_'||Technology,	Technology||'_ADD_UNIMPROVED_'||Resource||'_'||Yield		
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

-- Modifiers for improved = 1, unimproved = 1 (resource is visible)
INSERT INTO Modifiers
		(ModifierId,											ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Technology||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_VISIBLE_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId													) 
SELECT	'TECH_'||Technology,	Technology||'_ADD_VISIBLE_'||Resource||'_'||Yield		
FROM	AYCT_Technology_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

DROP Table AYCT_Technology_ResourceYieldChanges_Strings;

-------------------------------------
-- Technology_FeatureYieldChanges --
-------------------------------------

CREATE TEMPORARY TABLE AYCT_Technology_FeatureYieldChanges_Strings AS
SELECT substr(TechnologyType, 6) AS Technology, substr(FeatureType,9) AS Feature, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange, Improved AS Improved, Unimproved AS Unimproved
FROM Technology_FeatureYieldChanges;

-- Modifiers for improved = 1, unimproved = 1
INSERT INTO Modifiers
		(ModifierId,											ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_'||Yield,		'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_REQUIREMENTS'
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;
 
INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId					)
SELECT	'TECH_'||Technology,	Technology||'_ADD_FEATURE_'||Feature||'_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

-- Modifiers for improved = 1, unimproved = 0
INSERT INTO Modifiers
		(ModifierId,															ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId									) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_ANY_IMPROVEMENT_REQUIREMENTS'
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,															Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,															Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;
 
INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId															) 
SELECT	'TECH_'||Technology,	Technology||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

-- Modifiers for improved = 0, unimproved = 1;
INSERT INTO Modifiers
		(ModifierId,															ModifierType,								RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId									) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,		'MODIFIER_PLAYER_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_NO_IMPROVEMENT_REQUIREMENTS'
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,															Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,														Name,			Type,				Value			) 
SELECT	Technology||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,	'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;
 
INSERT INTO TechnologyModifiers
		(TechnologyType,		ModifierId															) 
SELECT	'TECH_'||Technology,	Technology||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield	
FROM	AYCT_Technology_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

DROP TABLE AYCT_Technology_FeatureYieldChanges_Strings;

-----------------------------------
-- Building_ResourceYieldChanges --
-----------------------------------

CREATE TEMPORARY TABLE AYCT_Building_ResourceYieldChanges_Strings AS
SELECT substr(BuildingType, 10) AS Building, substr(ResourceType,10) AS Resource, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange, Improved AS Improved, Unimproved AS Unimproved
FROM Building_ResourceYieldChanges;

-- Modifiers for improved = 1, unimproved = 0
INSERT INTO Modifiers
		(ModifierId,											ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Building||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_IMPROVED_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_IMPROVED_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO BuildingModifiers
		(BuildingType,				ModifierId													) 
SELECT	'BUILDING_'||Building,	Building||'_ADD_IMPROVED_'||Resource||'_'||Yield		
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

-- Modifiers for improved = 0, unimproved = 1
INSERT INTO Modifiers
		(ModifierId,											ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Building||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,		'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_UNIMPROVED_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_UNIMPROVED_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO BuildingModifiers
		(BuildingType,				ModifierId													) 
SELECT	'BUILDING_'||Building,		Building||'_ADD_UNIMPROVED_'||Resource||'_'||Yield		
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

-- Modifiers for improved = 1, unimproved = 1
INSERT INTO Modifiers
		(ModifierId,											ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Building||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_VISIBLE_'||Resource||'_REQUIREMENTS'
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,											Name,			Type,				Value			) 
SELECT	Building||'_ADD_VISIBLE_'||Resource||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO BuildingModifiers
		(BuildingType,				ModifierId													) 
SELECT	'BUILDING_'||Building,		Building||'_ADD_VISIBLE_'||Resource||'_'||Yield		
FROM	AYCT_Building_ResourceYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

DROP TABLE AYCT_Building_ResourceYieldChanges_Strings;

----------------------------------
-- Building_FeatureYieldChanges --
----------------------------------

CREATE TEMPORARY TABLE AYCT_Building_FeatureYieldChanges_Strings AS
SELECT substr(BuildingType, 10) AS Building, substr(FeatureType,9) AS Feature, substr(YieldType, 7) AS Yield, YieldChange AS YieldChange, Improved AS Improved, Unimproved AS Unimproved
FROM Building_FeatureYieldChanges;

-- Modifiers for improved = 1, unimproved = 1
INSERT INTO Modifiers
		(ModifierId,											ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId								) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_'||Yield,			'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_REQUIREMENTS'
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,										Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,										Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;
 
INSERT INTO BuildingModifiers
		(BuildingType,			ModifierId											)
SELECT	'BUILDING_'||Building,	Building||'_ADD_FEATURE_'||Feature||'_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 1;

-- Modifiers for improved = 1, unimproved = 0
INSERT INTO Modifiers
		(ModifierId,														ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId									) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_ANY_IMPROVEMENT_REQUIREMENTS'
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,														Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

INSERT INTO ModifierArguments
		(ModifierId,														Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;
 
INSERT INTO BuildingModifiers
		(BuildingType,			ModifierId											)
SELECT	'BUILDING_'||Building,	Building||'_ADD_FEATURE_'||Feature||'_ANY_IMPROVEMENT_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 1 AND Unimproved = 0;

-- Modifiers for improved = 0, unimproved = 1;
INSERT INTO Modifiers
		(ModifierId,														ModifierType,										RunOnce,	NewOnly,	Permanent,	SubjectRequirementSetId									) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,		'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD',		'0',		'0',		'0',		'PLOT_HAS_'||Feature||'_NO_IMPROVEMENT_REQUIREMENTS'
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1; 

INSERT INTO ModifierArguments
		(ModifierId,														Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,		'YieldType',	'ARGTYPE_IDENTITY',	'YIELD_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

INSERT INTO ModifierArguments
		(ModifierId,														Name,			Type,				Value			) 
SELECT	Building||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield,		'Amount',		'ARGTYPE_IDENTITY',	YieldChange	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;
 
INSERT INTO BuildingModifiers
		(BuildingType,			ModifierId											)
SELECT	'BUILDING_'||Building,	Building||'_ADD_FEATURE_'||Feature||'_NO_IMPROVEMENT_'||Yield	
FROM	AYCT_Building_FeatureYieldChanges_Strings 
WHERE	Improved = 0 AND Unimproved = 1;

DROP TABLE AYCT_Building_FeatureYieldChanges_Strings;